set nocount on
go

create table N8000 (
  N int not null primary key
)
go
insert into N8000 values (0)
while @@rowcount < 4000 begin
update N8000 set
  N = 2*N
insert into N8000
  select N+1 from N8000
end
go
delete from N8000 where N > 8000
--select * from N8000
go

create view V as
select
  cast(N as bigint) N,
  cast(C as tinyint) C,
  S
from OpenRowSet('Microsoft.Jet.OLEDB.4.0',
'Excel 8.0;Database=c:\Excel\Connections.xls',NumNamesEN$)
go


create function NumName (
  @i bigint
) returns nvarchar(1000) as begin
  if @i < 0 begin
    set @i = -@i
    return 'negative ' + dbo.NumName(@i)
  end
  declare @s nvarchar(1000)
  declare @n bigint, @left bigint, @right bigint, @c tinyint
-- find biggest value in table less than 
-- or equal to the number to translate
-- into words:
  select top 1 @s = S, @n = N, @c = C
  from V
  where N <= @i
  order by N desc
  if @n = 0 return @s
  set @left = @i/@n  -- "how many" 
  set @right = @i%@n -- "what's left"
  if @left > 1 or @c = 1 set @s = ltrim(rtrim(dbo.NumName(@left))) + space(1) + @s
  if @right > 0 set @s = @s + space(1) + ltrim(rtrim(dbo.NumName(@right)))
  return @s
end
go

declare @Vals varchar(1000)
set @Vals =
'0000000070,0000000000,0000000111,0000010000,0010000100,1234567891,0003400203,      1001,      2001,      2010,      2011'
select Nbr, dbo.NumName(Nbr)
from (
  select substring(@Vals,1+N*11,10) Nbr
  from N8000
  where N < len(@Vals)/11
) Nums
go

drop function NumName
drop view V
drop table N8000
